/*
 * 操作日志
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.BsModels;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class OperateLogController : BaseController
    {
        public OperateLogController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["BsSqlConnStr"].ToString();
        }

        #region 操作日志列表

        /// <summary>
        /// 根据条件查询操作日志列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(OperateLog data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            

            string Condition = "";
            Condition += "TableEnName:\"" + data.TableEnName + "\",";
Condition += "OperateMan:\"" + data.OperateMan + "\",";

            if (!string.IsNullOrEmpty(Condition))
            { 
                Condition = Condition.TrimEnd(',');
                Condition = ", where: {" + Condition + "}";
            }
            ViewBag.Condition = Condition;
            return View();
        }

        #endregion

        #region 根据条件查询操作日志列表

        /// <summary>
        /// 操作日志列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(OperateLog data, int page = 1, int limit = 30)
        {
            
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            
            Fields.Add("TableEnName", "2"); //表
Fields.Add("CreateDate", "3"); //时间
Fields.Add("OperateMan", "2"); //操作员

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).IndexData("OperateLog", Fields, "Id desc", "0", page, limit, " and Status>-1");
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                
            }
            return Json(obj);
        }

        #endregion

        #region 增加操作日志

        /// <summary>
        /// 增加或修改操作日志信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            

            return View();
        }

        #endregion

        #region 增加操作日志

        /// <summary>
        /// 增加或修改操作日志信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(OperateLog data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            
            
            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).Add("OperateLog", Fields, 0);
            AddSysLog(data.Id.ToString(), "OperateLog", "add");
            bsdb.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 修改操作日志

        /// <summary>
        /// 增加或修改操作日志信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            

            OperateLog editData = bsdb.OperateLog.FirstOrDefault(m => m.Id == Id) ?? new OperateLog();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改操作日志

        /// <summary>
        /// 增加或修改操作日志信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(OperateLog data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            
            
            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).Edit("OperateLog", Fields, data.Id);
            AddSysLog(data.Id.ToString(),"OperateLog","update");
            bsdb.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 删除操作日志信息

        /// <summary>
        /// 删除操作日志信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"OperateLog","del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).Edit("OperateLog", Fields, id);
            }
            bsdb.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"OperateLog","open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).Edit("OperateLog", Fields, id);
            }
            bsdb.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"OperateLog","close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).Edit("OperateLog", Fields, id);
            }
            bsdb.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).Sort("OperateLog", Sort, Id);
            
            AddSysLog(Id.ToString(), "OperateLog", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count;i++ )
            {
                JsonData dr = list[i];
                
                bsdb.OperateLog.Add(new OperateLog()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,
                    
                });
                bsdb.SaveChanges();
            }
            AddSysLog("0", "OperateLog", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(OperateLog data)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("TableEnName", "2"); //表
Fields.Add("CreateDate", "3"); //时间
Fields.Add("OperateMan", "2"); //操作员

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).IndexData("OperateLog", Fields, "Id desc", "0", 1, 20000, "", "TableEnName,OperateMan", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                
            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            ReturnFields.Add("TableEnName", "表");
ReturnFields.Add("OperateMan", "操作员");

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "OperateLog", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
